<?php 
if (isset($_GET['code'])) { die(highlight_file(__FILE__, 1)); }  
############################################################################ 
# A Project of TNET Services, Inc. and Saratoga-Weather.org (WD-ML template set) 
############################################################################ 
# 
#   Project:    Records page for templates 
#   Module:     wxyearlyrecords.php 
#   Purpose:    Display Station Yearly Records 
#   Authors:    Dennis Clapperton <webmaster@eastmasonvilleweather.com> 
#               East Masonville Weather 
#   Version:	2.00
# 
############################################################################ 
# This program is free software; you can redistribute it and/or 
# modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation; either version 2 
# of the License, or (at your option) any later version. 
# 
# This program is distributed in the hope that it will be useful, 
# but WITHOUT ANY WARRANTY; without even the implied warranty of 
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
# GNU General Public License for more details. 
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software 
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA 
############################################################################ 
#    This document uses Tab 4 Settings 
############################################################################ 
require_once("Settings.php"); 
############################################################################ 
$TITLE= $SITE['organ'] . " - Current Year Records"; 
$showGizmo = false;  // set to false to exclude the gizmo 
include("top.php"); 
############################################################################ 
?> 
</head> 
<body> 
<?php 
############################################################################ 
include("header.php"); 
############################################################################ 
include("menubar.php"); 
############################################################################ 
// 
//error_reporting(E_ALL);
// --- settings for standalone use --------------------------
$uomTemp = '&deg;F';
$uomBaro = ' inHg';
$uomWind = ' mph';
$uomRain = ' in';
$uomSnow = ' in';
$uomPerHour = '/hr';
$uomDistance = ' Miles';
$uomSolar = ' W/m&sup2;';
//  $timeFormat = 'D, d-M-Y g:ia T';  // Fri, 31-Mar-2006 6:35pm TZone
$timeFormat = 'd-M-Y g:ia';  // Fri, 31-Mar-2006 6:35pm TZone
$timeOnlyFormat = 'g:ia';    // h:mm[am|pm];
//$timeOnlyFormat = 'H:i';     // hh:mm  
//$dateOnlyFormat = 'j/n/Y';   // d/Mon/YYYY 
$dateOnlyFormat = 'n/j/Y';  // Mon/d/YYYY      
// --- Necessary Settings ---------------------------------------------------------------
$started   = '01/01';  // Date weather station started for yearly records
$rateinmin = false;		  // set to false if you want the rain rate in units/hour
$useTEMP   = true;        // set to false to not show Temperature readings section
$useWIND   = true;        // set to false to not show Wind readings section
$useRAIN   = true;        // set to false to not show Rain readings section
$useHUM    = true;        // set to false to not show Humidity readings section
$useDEW    = true;        // set to false to not show Dew Point readings section
$useBARO   = true;        // set to false to not show Barometer readings section
$useSOLAR  = true;       // set to false to not show Solar readings section
$useUV     = true;       // set to false to not show UV readings section

// allow viewing of generated source

if ( isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
//--self downloader --
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   
   readfile($filenameReal);
   exit;
}


// overrides from Settings.php if available

include_once("Settings.php");
include_once("common.php");
if (isset($SITE['WXtags'])) {
  include_once($SITE['WXtags']);
}

global $SITE;
if (isset($SITE['uomTemp'])) 	{$uomTemp = $SITE['uomTemp'];}
if (isset($SITE['uomBaro'])) 	{$uomBaro = $SITE['uomBaro'];}
if (isset($SITE['uomWind'])) 	{$uomWind = $SITE['uomWind'];}
if (isset($SITE['uomRain'])) 	{$uomRain = $SITE['uomRain'];}
if (isset($SITE['uomPerHour'])) {$uomPerHour = $SITE['uomPerHour'];}
if (isset($SITE['uomDistance'])) {$uomDistance = $SITE['uomDistance'];}
if (isset($SITE['timeFormat'])) {$timeFormat = $SITE['timeFormat'];}
if (isset($SITE['timeOnlyFormat'])) {$timeOnlyFormat = $SITE['timeOnlyFormat'];}
if (isset($SITE['WDdateMDY']))  {$WDdateMDY = $SITE['WDdateMDY'];}
if (isset($SITE['tz'])) 		{$ourTZ = $SITE['tz'];}
if (isset($SITE['UV'])) 		{$haveUV = $SITE['UV'];}
if (isset($SITE['SOLAR'])) 		{$haveSolar = $SITE['SOLAR'];}
// end of overrides from Settings.php
// testing parameters
$DebugMode = false;
if (isset($_REQUEST['debug'])) {$DebugMode = strtolower($_REQUEST['debug']) == 'y'; }
if (isset($_REQUEST['UV'])) {$haveUV = $_REQUEST['UV'] <> '0';}
if (isset($_REQUEST['solar'])) {$haveSolar = $_REQUEST['solar'] <> '0';}
if(! function_exists('langtrans') ) {
	function langtrans($str) { echo $str; return; }
}
if(! function_exists('langtransstr') ) {
	function langtransstr($str) { return($str); }
}

// ---------------- END OF SETTINGS ---------------- //

// ------------------- FUNCTIONS ------------------- //
//=========================================================================
// now split temps and dates for warmest/coldest night/day records Thanks Niko

   $started = date_parse($started);
   
   list($ywarmestdayonrecord_temp, $date) = explode('  on: ', $ywarmestdayonrecord);
   $date = strtotime($date);
   $ywarmestdayonrecord_date = date($dateOnlyFormat,$date);
   
   list($ywarmestnightonrecord_temp, $date) = explode('  on: ', $ywarmestnightonrecord);
   $date = strtotime($date);
   $ywarmestnightonrecord_date = date($dateOnlyFormat,$date);
   
   list($ycoldestdayonrecord_temp, $date) = explode('  on: ', $ycoldestdayonrecord);
   $date = strtotime($date);
   $ycoldestdayonrecord_date = date($dateOnlyFormat,$date);
   
   list($ycoldestnightonrecord_temp, $date) = explode('  on: ', $ycoldestnightonrecord);
   $date = strtotime($date);
   $ycoldestnightonrecord_date = date($dateOnlyFormat,$date);

//=========================================================================
// Start of table and page
?>
<div id="main-copy"> 
    <div align="center"> 
<table width="99%" cellpadding="0" cellspacing="0" border="0">

	<tr class="table-top" style="text-align: center">
		<td colspan="3"><p><?php echo langtrans('Current Year Records'); ?></p>
  						<p><?php echo langtrans('Data collected since'); ?> <?php datesep($started['month'],$started['day'],$date_year, $dateOnlyFormat); ?></p></td>
	</tr>
	<tr>
		<td colspan="3">&nbsp;</td>
	</tr>
    <?php
  if ($useTEMP) {  //  Show Temperature Data
    ?>
    <tr class="table-top">
		<td colspan="3" align="center"><br />
	    <?php echo langtrans('Temperature Records'); ?><br />
	    <br /></td>
	</tr>
	<tr class="column-light">
		<td width="46%" align="left"><?php echo langtrans('Highest Temperature'); ?></td>
		<td width="32%" align="left"><?php echo strip_unit($yrecordhightemp) . $uomTemp; ?></td>
		<td width="22%" align="right"><?php datesep($yrecordhightempmonth, $yrecordhightempday, $yrecordhightempyear, $dateOnlyFormat); ?></td>
	</tr>
	<tr class="column-dark">
  		<td align="left"><?php echo langtrans('Lowest Temperature'); ?></td>
		<td align="left"><?php echo strip_unit($yrecordlowtemp) . $uomTemp; ?></td>
		<td align="right"><?php datesep($yrecordlowtempmonth, $yrecordlowtempday, $yrecordlowtempyear, $dateOnlyFormat); ?></td>
	</tr>
	<tr class="column-light">
		<td align="left"><?php echo langtrans('Highest Heat Index'); ?></td>
		<td align="left"><?php echo strip_unit($yrecordhighheatindex) . $uomTemp; ?></td>
		<td align="right"><?php datesep($yrecordhighheatindexmonth, $yrecordhighheatindexday, $yrecordhighheatindexyear, $dateOnlyFormat); ?></td>
	</tr>
	<tr class="column-dark">
		<td align="left"><?php echo langtrans('Lowest Wind Chill'); ?></td>
		<td align="left"><?php echo strip_unit($yrecordlowchill) . $uomTemp; ?></td>
		<td align="right"><?php datesep($yrecordlowchillmonth, $yrecordlowchillday, $yrecordlowchillyear, $dateOnlyFormat); ?></td>
	</tr>
	<tr class="column-light">
		<td align="left"><?php echo langtrans('Warmest Day'); ?> <?php
                      if ($timeOnlyFormat = 'g:ia') 
                          echo ('(6am - 6pm)');
                      else    
                          echo ('(6 - 18)');
                   ?></td>
		<td align="left"><?php echo $ywarmestdayonrecord_temp; ?></td>
		<td align="right"><?php echo $ywarmestdayonrecord_date; ?></td>
	</tr>
	<tr class="column-dark">
  		<td align="left"><?php echo langtrans('Warmest Night'); ?> <?php
                      if ($timeOnlyFormat = 'g:ia') 
                          echo ('(6pm - 6am)');
                      else    
                          echo ('(18 - 6)');
                   ?></td>
		<td align="left"><?php echo $ywarmestnightonrecord_temp; ?></td>
		<td align="right"><?php echo $ywarmestnightonrecord_date; ?></td>
	</tr>
	<tr class="column-light">
  		<td align="left"><?php echo langtrans('Coldest Day'); ?> <?php
                      if ($timeOnlyFormat = 'g:ia') 
                          echo ('(6am - 6pm)');
                      else    
                          echo ('(6 - 18)');
                   ?></td>
		<td align="left"><?php echo $ycoldestdayonrecord_temp; ?></td>
		<td align="right"><?php echo $ycoldestdayonrecord_date; ?></td>
	</tr>
	<tr class="column-dark">
  		<td align="left"><?php echo langtrans('Coldest Night'); ?> <?php
                      if ($timeOnlyFormat = 'g:ia') 
                          echo ('(6pm - 6am)');
                      else    
                          echo ('(18 - 6)');
                   ?></td>
		<td align="left"><?php echo $ycoldestnightonrecord_temp; ?></td>
		<td align="right"><?php echo $ycoldestnightonrecord_date; ?></td>
	</tr>
	<tr>
		<td colspan="3" style="height: 21px" ></td>
	</tr>
<?php } //End Temperature Records
?>
<?php
  if ($useWIND) {  //  Show Wind Records
    ?>
    <tr class="table-top">
		<td colspan="3" align="center"><br />
	    <?php echo langtrans('Wind Records'); ?><br />
	    <br /></td>
	</tr>
	<tr class="column-light">
		<td align="left"><?php echo langtrans('Maximum Wind Gust'); ?></td>
		<td align="left"><?php echo strip_unit($yrecordwindgust) . $uomWind; ?></td>
		<td align="right"><?php datesep($yrecordhighgustmonth, $yrecordhighgustday, $yrecordhighgustyear, $dateOnlyFormat); ?></td>
	</tr>
	<tr class="column-dark">
  		<td align="left"><?php echo langtrans('Highest Average Speed'); ?></td>
		<td align="left"><?php echo strip_unit($yrecordwindspeed) . $uomWind; ?></td>
		<td align="right"><?php datesep($yrecordhighavwindmonth, $yrecordhighavwindday, $yrecordhighavwindyear, $dateOnlyFormat); ?></td>
	</tr>
	<tr class="column-light">
		<td align="left"><?php echo langtrans('Highest Daily Wind Run'); ?></td>
		<td align="left"><?php echo strip_unit($yrecordhighwindrun) . $uomDistance; ?></td>
		<td align="right"><?php datesep($yrecordhighwindrunmth, $yrecordhighwindrunday, $yrecordhighwindrunyr, $dateOnlyFormat); ?></td>
	</tr>
	<tr>
		<td colspan="3" style="height: 21px" ></td>
	</tr>
<?php } //End Wind Records
?>
<?php
  if ($useRAIN) {  //  Show Precipitation Records
    ?>
    <tr class="table-top">
		<td colspan="3" align="center"><br />
	    <?php echo langtrans('Precipitation Records'); ?><br />
	    <br /></td>
	</tr>
    <tr class="column-light">
		<td align="left"><?php echo langtrans('Highest Daily Precipitation'); ?></td>
		<td align="left"><?php echo strip_unit($yrecorddailyrain) . $uomRain; ?></td>
		<td align="right"><?php datesep($yrecorddailyrainmonth, $yrecorddailyrainday, $yrecorddailyrainyear, $dateOnlyFormat); ?></td>
	</tr>
	<tr class="column-dark">
		<td align="left"><?php echo langtrans('Highest Precipitation Rate'); ?></td>
		<td align="left"><?php if($rateinmin){		
									echo strip_unit($yrecordrainrate) . $uomRain ."/min"; 
								}else{
									echo strip_unit($yrecordrainrate*60) . $uomRain ."/hr";
								}
									?></td>
		<td align="right"><?php datesep($yrecordrainratemonth, $yrecordrainrateday, $yrecordrainrateyear, $dateOnlyFormat); ?></td>
	</tr>
	<tr class="column-light">
		<td align="left"><?php echo langtrans('Consecutive Days With Precipitation'); ?></td>
		<td align="left"><?php echo $yrecorddayswithrain; ?> <?php echo langtrans('Days'); ?></td>
		<td align="right"><?php echo langtrans('Ending'); ?>: <?php datesep($yrecorddayswithrainmonth, $yrecorddayswithrainday, $date_year, $dateOnlyFormat); ?></td>
	</tr>
	<tr class="column-dark">
		<td align="left"><?php echo langtrans('Consecutive Days Without Precipitation'); ?></td>
		<td align="left"><?php echo $yrecorddaysnorain; ?> <?php echo langtrans('Days'); ?></td>
		<td align="right"><?php echo langtrans('Ending'); ?>: <?php datesep($yrecorddaysnorainmonth, $yrecorddaysnorainday, $date_year, $dateOnlyFormat); ?></td>
	</tr>
	<tr>
		<td colspan="3" style="height: 21px" ></td>
	</tr>
<?php } //End Precipitation Records
?>
<?php // Find if we need to show this heading
  if (($useHUM) or ($useDEW)) {
?>
    <tr class="table-top">
		<td colspan="3" align="center"><br />
	    <?php echo langtrans('Humidity Records'); ?><br />
	    <br /></td>
	</tr>
    <?php
  if ($useHUM) {  //  Show Humidity Records
    ?>
    <tr class="column-light">
		<td align="left"><?php echo langtrans('Highest Humidity'); ?></td>
		<td align="left"><?php echo strip_unit($yrecordhighhum) . "%"; ?></td>
		<td align="right"><?php datesep($yrecordhighhummonth, $yrecordhighhumday, $yrecordhighhumyear, $dateOnlyFormat); ?></td>
	</tr>
	<tr class="column-dark">
  		<td align="left"><?php echo langtrans('Lowest Humidity'); ?></td>
		<td align="left"><?php echo strip_unit($yrecordlowhum) . "%"; ?></td>
		<td align="right"><?php datesep($yrecordlowhummonth, $yrecordlowhumday, $yrecordlowhumyear, $dateOnlyFormat); ?></td>
	</tr>
    <?php } // End Humidity Records
?>
    <?php
  if ($useDEW) {  //  Show Dew Point Records
    ?>
	<tr class="column-light">
		<td align="left"><?php echo langtrans('Highest Dewpoint'); ?></td>
		<td align="left"><?php echo strip_unit($yrecordhighdew) . $uomTemp; ?></td>
		<td align="right"><?php datesep($yrecordhighdewmonth, $yrecordhighdewday, $yrecordhighdewyear, $dateOnlyFormat); ?></td>
	</tr>
	<tr class="column-dark">
		<td align="left"><?php echo langtrans('Lowest Dewpoint'); ?></td>
		<td align="left"><?php echo strip_unit($yrecordlowdew) . $uomTemp; ?></td>
		<td align="right"><?php datesep($yrecordlowdewmonth, $yrecordlowdewday, $yrecordlowdewyear, $dateOnlyFormat); ?></td>
	</tr>
        <?php } // End Humidity Records
?>
    <tr>
		<td colspan="3" style="height: 21px" ></td>
	</tr>
    <?php } // End Humidity or Dew Point Records
?>
<?php
  if ($useBARO) {  //  Show Barometer Records
    ?>
    <tr class="table-top">
		<td colspan="3" align="center"><br />
	    <?php echo langtrans('Barometer Records'); ?><br />
	    <br /></td>
	</tr>
        <tr class="column-light">
		<td align="left"><?php echo langtrans('Highest Barormeter'); ?></td>
		<td align="left"><?php echo strip_unit($yrecordhighbaro) . $uomBaro; ?></td>
		<td align="right"><?php datesep($yrecordhighbaromonth, $yrecordhighbaroday, $yrecordhighbaroyear, $dateOnlyFormat); ?></td>
	</tr>
	<tr class="column-dark">
  		<td align="left"><?php echo langtrans('Lowest Barometer'); ?></td>
		<td align="left"><?php echo strip_unit($yrecordlowbaro) . $uomBaro; ?></td>
		<td align="right"><?php datesep($yrecordlowbaromonth, $yrecordlowbaroday, $yrecordlowbaroyear, $dateOnlyFormat); ?></td>
	</tr>
    	<tr>
		<td colspan="3" style="height: 21px" ></td>
	</tr>
        <?php } // Barometer Records
?>
		<?php // Find if we need to show this heading
  if (($useSOLAR) or ($useUV)) {
?>
    <tr class="table-top">
		<td colspan="3" align="center"><br />
	    <?php echo langtrans('Sun Records'); ?><br />
	    <br /></td>
	</tr>
        <?php
  if ($useSOLAR) {  //  Show Solar Records
    ?>
	<tr class="column-light">
		<td align="left"><?php echo langtrans('Highest Solar Radiation'); ?></td>
		<td align="left"><?php echo strip_unit($yrecordhighsolar) . $uomSolar; ?></td>
		<td align="right"><?php datesep($yrecordhighsolarmonth, $yrecordhighsolarday, $yrecordhighsolaryear, $dateOnlyFormat); ?></td>
	</tr>
            <?php } // End Solar Records ?>
            <?php
  if ($useUV) {  //  Show UV Records ?>
	<tr class="column-dark">
		<td align="left"><?php echo langtrans('Highest UV'); ?></td>
		<td align="left"><?php echo strip_unit($yrecordhighuv) ?></td>
		<td align="right"><?php datesep($yrecordhighuvmonth, $yrecordhighuvday, $yrecordhighuvyear,$dateOnlyFormat); ?></td>
	</tr>
    	<?php } // End UV Records ?>
     <tr>
		<td colspan="3" style="height: 21px" ></td>
	</tr>
        <?php } // End Solar Records ?>
</table>
</div> 
</div><!-- end main-copy --> 


<?php 
############################################################################ 
include("footer.php"); 
// ------------------- FUNCTIONS ------------------- //
//=========================================================================
// strip trailing units from a measurement

function strip_unit ($data) {
  preg_match('/([\d\.\+\-]+)/',$data,$t);
  return $t[1];
}

function datesep($month, $day, $year,$dateOnlyFormat){
	$date= $month ."/". $day ."/". $year;
	$date = strtotime($date);
	echo date($dateOnlyFormat,$date);
}
// END OF FUNCTIONS
############################################################################ 
# End of Page 
############################################################################ 
?>